package com.soywiz.korlibs.tensork.backend

enum class TensorOp {
    // Arithmetic / Basic
    all,
    relu,
    abs,
    neg,
    cos,
    sin,
    acos,
    acosh,
    asin,
    asinh,
    max,
    min,
    add,
    sub,
    mul,
    div,
    divNoNan,
    floorDiv,
    mod,
    pow,
    squareDifference,
    softplus,
    sinh,
    sqrt,
    square,
    step,
    tan,
    tanh,
    atan,
    atan2,
    atanh,
    ceil,
    clipByValue,
    cosh,
    elu,
    erf,
    exp,
    expm1,
    floor,
    isFinite,
    isNaN,
    leakyRelu,
    log,
    log1p,
    logSigmoid,
    prelu,
    reciprocal,
    relu6,
    round,
    rsqrt,
    selu,
    sigmoid,
    sign,
    // Matrix
    dot,
    matMul,
    norm,
    outerProd,
    transpose,
    // Logical
    equal,
    greater,
    greaterEqual,
    less,
    lessEqual,
    logicalAnd,
    logicalNot,
    logicalOr,
    logicalXor,
    notEqual,
    where,
}
